#ifndef FEMMEDIUM_H
#define FEMMEDIUM_H

#include "fem.h"
#include <Eigen/Dense>

namespace fem
{

/// physical properties on a domain defined by a group

class FEM_API Medium
{
public:
#ifndef SWIG
    double m_E;  ///< Young's modulus
    double m_nu; ///< Poisson's ratio
    Group *group;

    Eigen::MatrixXd H2D; ///< Hooke
    Eigen::MatrixXd H3D; ///< Hooke
#endif

public:
    Medium(Problem &pbl, std::string const &groupname, double E, double nu);
    ~Medium();

#ifndef SWIG
    Eigen::MatrixXd &hooke(int ndim) 
    {
        return (ndim==2)? H2D : H3D;
    }

    friend FEM_API std::ostream &operator<<(std::ostream &out, Medium const &obj);
#endif
};

} // namespace fem

#endif // FEMMEDIUM_H
